# Copyright (c) 2011 The Chromium Embedded Framework Authors. All rights
# reserved. Use of this source code is governed by a BSD-style license that
# can be found in the LICENSE file.

{
  'includes': [
    # Bring in the autogenerated source file lists.
    'cef_paths.gypi',
   ],
  'variables': {
    'includes_common': [
      'include/base/cef_atomic_ref_count.h',
      'include/base/cef_atomicops.h',
      'include/base/cef_basictypes.h',
      'include/base/cef_bind.h',
      'include/base/cef_bind_helpers.h',
      'include/base/cef_build.h',
      'include/base/cef_callback.h',
      'include/base/cef_callback_forward.h',
      'include/base/cef_callback_helpers.h',
      'include/base/cef_callback_list.h',
      'include/base/cef_cancelable_callback.h',
      'include/base/cef_lock.h',
      'include/base/cef_logging.h',
      'include/base/cef_macros.h',
      'include/base/cef_move.h',
      'include/base/cef_platform_thread.h',
      'include/base/cef_ref_counted.h',
      'include/base/cef_scoped_ptr.h',
      'include/base/cef_string16.h',
      'include/base/cef_template_util.h',
      'include/base/cef_thread_checker.h',
      'include/base/cef_thread_collision_warner.h',
      'include/base/cef_trace_event.h',
      'include/base/cef_tuple.h',
      'include/base/cef_weak_ptr.h',
      'include/base/internal/cef_bind_internal.h',
      'include/base/internal/cef_callback_internal.h',
      'include/base/internal/cef_lock_impl.h',
      'include/base/internal/cef_raw_scoped_refptr_mismatch_checker.h',
      'include/base/internal/cef_thread_checker_impl.h',
      'include/cef_base.h',
      'include/cef_pack_resources.h',
      'include/cef_pack_strings.h',
      'include/cef_runnable.h',
      'include/cef_version.h',
      'include/internal/cef_export.h',
      'include/internal/cef_logging_internal.h',
      'include/internal/cef_ptr.h',
      'include/internal/cef_string.h',
      'include/internal/cef_string_list.h',
      'include/internal/cef_string_map.h',
      'include/internal/cef_string_multimap.h',
      'include/internal/cef_string_types.h',
      'include/internal/cef_string_wrappers.h',
      'include/internal/cef_thread_internal.h',
      'include/internal/cef_time.h',
      'include/internal/cef_trace_event_internal.h',
      'include/internal/cef_types.h',
      'include/internal/cef_types_wrappers.h',
      '<@(autogen_cpp_includes)',
    ],
    'includes_capi': [
      'include/capi/cef_base_capi.h',
      '<@(autogen_capi_includes)',
    ],
    'includes_wrapper': [
      'include/wrapper/cef_byte_read_handler.h',
      'include/wrapper/cef_closure_task.h',
      'include/wrapper/cef_helpers.h',
      'include/wrapper/cef_message_router.h',
      'include/wrapper/cef_resource_manager.h',
      'include/wrapper/cef_stream_resource_handler.h',
      'include/wrapper/cef_xml_object.h',
      'include/wrapper/cef_zip_archive.h',
    ],
    'includes_win': [
      'include/base/internal/cef_atomicops_x86_msvc.h',
      'include/base/internal/cef_bind_internal_win.h',
      'include/cef_sandbox_win.h',
      'include/internal/cef_types_win.h',
      'include/internal/cef_win.h',
    ],
    'includes_mac': [
      'include/base/internal/cef_atomicops_atomicword_compat.h',
      'include/base/internal/cef_atomicops_mac.h',
      'include/cef_application_mac.h',
      'include/internal/cef_mac.h',
      'include/internal/cef_types_mac.h',
    ],
    'includes_linux': [
      'include/base/internal/cef_atomicops_atomicword_compat.h',
      'include/base/internal/cef_atomicops_x86_gcc.h',
      'include/internal/cef_linux.h',
      'include/internal/cef_types_linux.h',
    ],
    'libcef_sources_common': [
      'libcef_dll/cpptoc/cpptoc.h',
      'libcef_dll/ctocpp/base_ctocpp.cc',
      'libcef_dll/ctocpp/base_ctocpp.h',
      'libcef_dll/ctocpp/ctocpp.h',
      'libcef_dll/libcef_dll.cc',
      'libcef_dll/libcef_dll2.cc',
      'libcef_dll/resource.h',
      'libcef_dll/transfer_util.cc',
      'libcef_dll/transfer_util.h',
      'libcef_dll/wrapper_types.h',
      '<@(autogen_library_side)',
    ],
    'libcef_dll_wrapper_sources_common': [
      'libcef_dll/base/cef_atomicops_x86_gcc.cc',
      'libcef_dll/base/cef_bind_helpers.cc',
      'libcef_dll/base/cef_callback_helpers.cc',
      'libcef_dll/base/cef_callback_internal.cc',
      'libcef_dll/base/cef_lock.cc',
      'libcef_dll/base/cef_lock_impl.cc',
      'libcef_dll/base/cef_logging.cc',
      'libcef_dll/base/cef_ref_counted.cc',
      'libcef_dll/base/cef_string16.cc',
      'libcef_dll/base/cef_thread_checker_impl.cc',
      'libcef_dll/base/cef_thread_collision_warner.cc',
      'libcef_dll/base/cef_weak_ptr.cc',
      'libcef_dll/cpptoc/base_cpptoc.cc',
      'libcef_dll/cpptoc/base_cpptoc.h',
      'libcef_dll/cpptoc/cpptoc.h',
      'libcef_dll/ctocpp/ctocpp.h',
      'libcef_dll/transfer_util.cc',
      'libcef_dll/transfer_util.h',
      'libcef_dll/wrapper_types.h',
      'libcef_dll/wrapper/cef_browser_info_map.h',
      'libcef_dll/wrapper/cef_byte_read_handler.cc',
      'libcef_dll/wrapper/cef_closure_task.cc',
      'libcef_dll/wrapper/cef_message_router.cc',
      'libcef_dll/wrapper/cef_resource_manager.cc',
      'libcef_dll/wrapper/cef_stream_resource_handler.cc',
      'libcef_dll/wrapper/cef_xml_object.cc',
      'libcef_dll/wrapper/cef_zip_archive.cc',
      'libcef_dll/wrapper/libcef_dll_wrapper.cc',
      'libcef_dll/wrapper/libcef_dll_wrapper2.cc',
      '<@(autogen_client_side)',
    ],
    'cefclient_sources_browser': [
      'tests/cefclient/browser/binding_test.cc',
      'tests/cefclient/browser/binding_test.h',
      'tests/cefclient/browser/browser_window.cc',
      'tests/cefclient/browser/browser_window.h',
      'tests/cefclient/browser/bytes_write_handler.cc',
      'tests/cefclient/browser/bytes_write_handler.h',
      'tests/cefclient/browser/client_app_browser.cc',
      'tests/cefclient/browser/client_app_browser.h',
      'tests/cefclient/browser/client_app_delegates_browser.cc',
      'tests/cefclient/browser/client_handler.cc',
      'tests/cefclient/browser/client_handler.h',
      'tests/cefclient/browser/client_handler_osr.cc',
      'tests/cefclient/browser/client_handler_osr.h',
      'tests/cefclient/browser/client_handler_std.cc',
      'tests/cefclient/browser/client_handler_std.h',
      'tests/cefclient/browser/client_types.h',
      'tests/cefclient/browser/dialog_test.cc',
      'tests/cefclient/browser/dialog_test.h',
      'tests/cefclient/browser/geometry_util.cc',
      'tests/cefclient/browser/geometry_util.h',
      'tests/cefclient/browser/main_context.cc',
      'tests/cefclient/browser/main_context.h',
      'tests/cefclient/browser/main_context_impl.cc',
      'tests/cefclient/browser/main_context_impl.h',
      'tests/cefclient/browser/main_message_loop.h',
      'tests/cefclient/browser/main_message_loop.cc',
      'tests/cefclient/browser/main_message_loop_std.h',
      'tests/cefclient/browser/main_message_loop_std.cc',
      'tests/cefclient/browser/osr_dragdrop_events.h',
      'tests/cefclient/browser/osr_renderer.h',
      'tests/cefclient/browser/osr_renderer.cc',
      'tests/cefclient/browser/preferences_test.cc',
      'tests/cefclient/browser/preferences_test.h',
      'tests/cefclient/browser/resource.h',
      'tests/cefclient/browser/resource_util.h',
      'tests/cefclient/browser/response_filter_test.cc',
      'tests/cefclient/browser/response_filter_test.h',
      'tests/cefclient/browser/root_window.cc',
      'tests/cefclient/browser/root_window.h',
      'tests/cefclient/browser/root_window_manager.cc',
      'tests/cefclient/browser/root_window_manager.h',
      'tests/cefclient/browser/scheme_test.cc',
      'tests/cefclient/browser/scheme_test.h',
      'tests/cefclient/browser/temp_window.h',
      'tests/cefclient/browser/test_runner.cc',
      'tests/cefclient/browser/test_runner.h',
      'tests/cefclient/browser/urlrequest_test.cc',
      'tests/cefclient/browser/urlrequest_test.h',
      'tests/cefclient/browser/window_test.cc',
      'tests/cefclient/browser/window_test.h',
    ],
    'cefclient_sources_common': [
      'tests/cefclient/common/client_app.cc',
      'tests/cefclient/common/client_app.h',
      'tests/cefclient/common/client_app_delegates_common.cc',
      'tests/cefclient/common/client_app_other.cc',
      'tests/cefclient/common/client_app_other.h',
      'tests/cefclient/common/client_switches.cc',
      'tests/cefclient/common/client_switches.h',
      'tests/cefclient/common/scheme_test_common.cc',
      'tests/cefclient/common/scheme_test_common.h',
    ],
    'cefclient_sources_renderer': [
      'tests/cefclient/renderer/client_app_delegates_renderer.cc',
      'tests/cefclient/renderer/client_app_renderer.cc',
      'tests/cefclient/renderer/client_app_renderer.h',
      'tests/cefclient/renderer/client_renderer.cc',
      'tests/cefclient/renderer/client_renderer.h',
      'tests/cefclient/renderer/performance_test.cc',
      'tests/cefclient/renderer/performance_test.h',
      'tests/cefclient/renderer/performance_test_setup.h',
      'tests/cefclient/renderer/performance_test_tests.cc',
    ],
    'cefclient_sources_resources': [
      'tests/cefclient/resources/binding.html',
      'tests/cefclient/resources/dialogs.html',
      'tests/cefclient/resources/localstorage.html',
      'tests/cefclient/resources/logo.png',
      'tests/cefclient/resources/osr_test.html',
      'tests/cefclient/resources/other_tests.html',
      'tests/cefclient/resources/pdf.html',
      'tests/cefclient/resources/pdf.pdf',
      'tests/cefclient/resources/performance.html',
      'tests/cefclient/resources/performance2.html',
      'tests/cefclient/resources/preferences.html',
      'tests/cefclient/resources/response_filter.html',
      'tests/cefclient/resources/transparency.html',
      'tests/cefclient/resources/urlrequest.html',
      'tests/cefclient/resources/window.html',
      'tests/cefclient/resources/xmlhttprequest.html',
    ],
    'cefclient_sources_win': [
      'tests/cefclient/browser/browser_window_osr_win.cc',
      'tests/cefclient/browser/browser_window_osr_win.h',
      'tests/cefclient/browser/browser_window_std_win.cc',
      'tests/cefclient/browser/browser_window_std_win.h',
      'tests/cefclient/browser/main_context_impl_win.cc',
      'tests/cefclient/browser/main_message_loop_multithreaded_win.cc',
      'tests/cefclient/browser/main_message_loop_multithreaded_win.h',
      'tests/cefclient/browser/osr_dragdrop_win.cc',
      'tests/cefclient/browser/osr_dragdrop_win.h',
      'tests/cefclient/browser/osr_window_win.cc',
      'tests/cefclient/browser/osr_window_win.h',
      'tests/cefclient/browser/resource_util_win.cc',
      'tests/cefclient/browser/root_window_win.cc',
      'tests/cefclient/browser/root_window_win.h',
      'tests/cefclient/browser/temp_window_win.cc',
      'tests/cefclient/browser/temp_window_win.h',
      'tests/cefclient/browser/util_win.cc',
      'tests/cefclient/browser/util_win.h',
      'tests/cefclient/browser/window_test_win.cc',
      'tests/cefclient/cefclient_win.cc',
      'tests/cefclient/resources/win/cefclient.exe.manifest',
      'tests/cefclient/resources/win/cefclient.ico',
      'tests/cefclient/resources/win/cefclient.rc',
      'tests/cefclient/resources/win/small.ico',
      '<@(cefclient_sources_browser)',
      '<@(cefclient_sources_common)',
      '<@(cefclient_sources_renderer)',
      '<@(cefclient_sources_resources)',
    ],
    'cefclient_sources_mac': [
      'tests/cefclient/browser/browser_window_osr_mac.h',
      'tests/cefclient/browser/browser_window_osr_mac.mm',
      'tests/cefclient/browser/browser_window_std_mac.h',
      'tests/cefclient/browser/browser_window_std_mac.mm',
      'tests/cefclient/browser/main_context_impl_posix.cc',
      'tests/cefclient/browser/resource_util_mac.mm',
      'tests/cefclient/browser/resource_util_posix.cc',
      'tests/cefclient/browser/root_window_mac.h',
      'tests/cefclient/browser/root_window_mac.mm',
      'tests/cefclient/browser/temp_window_mac.h',
      'tests/cefclient/browser/temp_window_mac.mm',
      'tests/cefclient/browser/window_test_mac.mm',
      'tests/cefclient/cefclient_mac.mm',
      '<@(cefclient_sources_browser)',
      '<@(cefclient_sources_common)',
   ],
    'cefclient_sources_mac_helper': [
      'tests/cefclient/process_helper_mac.cc',
      '<@(cefclient_sources_common)',
      '<@(cefclient_sources_renderer)',
    ],
    'cefclient_bundle_resources_mac': [
      'tests/cefclient/resources/mac/cefclient.icns',
      'tests/cefclient/resources/mac/English.lproj/InfoPlist.strings',
      'tests/cefclient/resources/mac/English.lproj/MainMenu.xib',
      'tests/cefclient/resources/mac/Info.plist',
      '<@(cefclient_sources_resources)',
    ],
    'cefclient_sources_linux': [
      'tests/cefclient/browser/browser_window_osr_gtk.cc',
      'tests/cefclient/browser/browser_window_osr_gtk.h',
      'tests/cefclient/browser/browser_window_std_gtk.cc',
      'tests/cefclient/browser/browser_window_std_gtk.h',
      'tests/cefclient/browser/dialog_handler_gtk.cc',
      'tests/cefclient/browser/dialog_handler_gtk.h',
      'tests/cefclient/browser/main_context_impl_posix.cc',
      'tests/cefclient/browser/print_handler_gtk.cc',
      'tests/cefclient/browser/print_handler_gtk.h',
      'tests/cefclient/browser/resource_util_linux.cc',
      'tests/cefclient/browser/resource_util_posix.cc',
      'tests/cefclient/browser/root_window_gtk.cc',
      'tests/cefclient/browser/root_window_gtk.h',
      'tests/cefclient/browser/temp_window_x11.cc',
      'tests/cefclient/browser/temp_window_x11.h',
      'tests/cefclient/browser/window_test_gtk.cc',
      'tests/cefclient/cefclient_gtk.cc',
      '<@(cefclient_sources_browser)',
      '<@(cefclient_sources_common)',
      '<@(cefclient_sources_renderer)',
    ],
    'cefclient_bundle_resources_linux': [
      '<@(cefclient_sources_resources)',
    ],
    'cefsimple_sources_common': [
      'tests/cefsimple/simple_app.cc',
      'tests/cefsimple/simple_app.h',
      'tests/cefsimple/simple_handler.cc',
      'tests/cefsimple/simple_handler.h',
    ],
    'cefsimple_sources_win': [
      'tests/cefsimple/cefsimple.exe.manifest',
      'tests/cefsimple/cefsimple.rc',
      'tests/cefsimple/cefsimple_win.cc',
      'tests/cefsimple/simple_handler_win.cc',
      'tests/cefsimple/resource.h',
      'tests/cefsimple/res/cefsimple.ico',
      'tests/cefsimple/res/small.ico',
    ],
    'cefsimple_sources_mac': [
      'tests/cefsimple/cefsimple_mac.mm',
      'tests/cefsimple/simple_handler_mac.mm',
    ],
    'cefsimple_sources_mac_helper': [
      'tests/cefsimple/process_helper_mac.cc',
    ],
    'cefsimple_bundle_resources_mac': [
      'tests/cefsimple/mac/cefsimple.icns',
      'tests/cefsimple/mac/English.lproj/InfoPlist.strings',
      'tests/cefsimple/mac/English.lproj/MainMenu.xib',
      'tests/cefsimple/mac/Info.plist',
    ],
    'cefsimple_sources_linux': [
      'tests/cefsimple/cefsimple_linux.cc',
      'tests/cefsimple/simple_handler_linux.cc',
    ],
  },
}
